>From 0f916f586b67a04a8ad3c1a9a0811e3da73f3c54 Mon Sep 17 00:00:00 2001
From: Carlos Maddela <maddela@labyrinth.net.au>
Date: Thu, 16 Jul 2015 00:35:23 +1000
Subject: [PATCH] Fix '502 Connection closed' bug.

---
 source/dlcon.cc | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

diff --git a/source/dlcon.cc b/source/dlcon.cc
index 2006e13..c2a4639 100644
--- a/source/dlcon.cc
+++ b/source/dlcon.cc
@@ -1205,6 +1205,8 @@ void dlcon::WorkLoop()
         			con = doconnect(peerHost, acfg::nettimeout, false);
         		}
 
+        		nLostConTolerance = MAX_RETRY + bUsed;
+
         		ldbg("connection valid? " << bool(con) << " was fresh? " << !bUsed);
 
         		if(con)
@@ -1346,10 +1348,7 @@ void dlcon::WorkLoop()
 		{
 			// disconnected by OS... give it a chance, or maybe not...
 			if (--nLostConTolerance <= 0)
-			{
 				BlacklistMirror(inpipe.front());
-				nLostConTolerance=MAX_RETRY;
-			}
 
 			timespec sleeptime = { 0, 325000000 };
 			nanosleep(&sleeptime, nullptr);
@@ -1364,6 +1363,7 @@ void dlcon::WorkLoop()
 
         if(loopRes & (HINT_DONE|HINT_MORE))
         {
+        	nLostConTolerance=MAX_RETRY;
         	sErrorMsg.clear();
         	continue;
         }
-- 
2.1.4

